<html>
<body>

<p><b>This example reads hierarchical data</b></p>

<p>The input to this example is the following XML file:</p>

<p><a href="../../../../../../../data/examples/fwXML/xmlExampleHierarchical.xml">xmlExampleHierarchical.xml</a></p>

<pre>
&lt;Earch>
 &lt;Europe>
  &lt;England lan="E">
  &lt;/England>
  &lt;Switzerland lan="F/I/D">
   &lt;Geneva lan="F">
    &lt;Geneva/>
    &lt;Meyrin/>
    &lt;Versoix/>
   &lt;/Geneva>
   &lt;Bern lan="D">
    &lt;Bern/>
   &lt;/Bern>
   &lt;Valais lan="F/D">
    &lt;Sion lan="F"/>
    &lt;Martigny lan="F"/>
   &lt;/Valais>
  &lt;/Switzerland>
 &lt;/Europe>
 &lt;America>
  &lt;Usa lan="E">
   &lt;New-York/>
   &lt;Florida>
   &lt;/Florida>
  &lt;/Usa>
  &lt;Brazil lan="P">
  &lt;/Brazil>
  &lt;Argentina lan="E"/>
 &lt;/America>
&lt;/Earch>
</pre>

<p>The code in the example calls the 'fwXml_childNodesContent()' function more than once:</p>

<pre>
rtn_code = fwXml_childNodesContent ( xml_doc_ident , top_elem_ident , node_names , attributes , nodevalues , exInfo );
</pre>

<p>One checks the return-code against what one expects, namely that it contains 
simple element nodes as well as complex element nodes.  In other words, the element node
in turn contain more than one child or not a text-node.</p>

<pre>
if ( fwXml_containsNodeTypes ( rtn_code , ( fwXml_CONTAINS_SIMPLE_ELEMENT_NODES
                                          | fwXml_CONTAINS_COMPLEX_ELEMENT_NODES ) ) )
</pre>

<p>The following is returned via the three output-parameters:</p>
<ul>
<li>'node_names' returns the tag-names of the element-nodes.
<li>'attributes' returns all the attributes of the element-nodes if present.<br>
    if the key 'fwXml_CHILDNODESTYPE' is present then one has to do with a element-node!
	In this case the key 'fwXml_CHILDSUBTREEID' will also be present that identifies the 'top_elem_ident' 
	to be used in the next call to the function 'fwXml_childNodesContent()'.
<li>'nodevalues' will be empty in this case...
</ul>

<p>The program then prints out the returned information in the three dynamic variables in the following form:</p>

<pre>
WCCOAui1:["document = 0"]
WCCOAui1:["1-child = 0"]
WCCOAui1:["topelem = [0] 'Earch'"]
WCCOAui1:["rtn_code = 2"]
WCCOAui1:["TagName = [1]    'Europe'"]
WCCOAui1:["rtn_code = 2"]
WCCOAui1:["TagName = [2]       'England'   Attribs 'lan:E'"]
WCCOAui1:["TagName = [2]       'Switzerland'   Attribs 'lan:F/I/D'"]
WCCOAui1:["rtn_code = 2"]
WCCOAui1:["TagName = [3]          'Geneva'   Attribs 'lan:F'"]
WCCOAui1:["rtn_code = 0"]
WCCOAui1:["TagName = [4]             'Geneva'"]
WCCOAui1:["TagName = [4]             'Meyrin'"]
WCCOAui1:["TagName = [4]             'Versoix'"]
WCCOAui1:["TagName = [3]          'Bern'   Attribs 'lan:D'"]
WCCOAui1:["rtn_code = 0"]
WCCOAui1:["TagName = [4]             'Bern'"]
WCCOAui1:["TagName = [3]          'Valais'   Attribs 'lan:F/D'"]
WCCOAui1:["rtn_code = 0"]
WCCOAui1:["TagName = [4]             'Sion'   Attribs 'lan:F'"]
WCCOAui1:["TagName = [4]             'Martigny'   Attribs 'lan:F'"]
WCCOAui1:["TagName = [1]    'America'"]
WCCOAui1:["rtn_code = 2"]
WCCOAui1:["TagName = [2]       'Usa'   Attribs 'lan:E'"]
WCCOAui1:["rtn_code = 0"]
WCCOAui1:["TagName = [3]          'New-York'"]
WCCOAui1:["TagName = [3]          'Florida'"]
WCCOAui1:["TagName = [2]       'Brazil'   Attribs 'lan:P'"]
WCCOAui1:["TagName = [2]       'Argentina'   Attribs 'lan:E'"]
WCCOAui1:["rtn_code = 0"]
</pre>

<p>&nbsp;</p>

</body>
</html>

